/*
 * Copyright (C) 2006-2007 blair christensen.
 * All Rights Reserved.
 *
 * You may use and distribute under the same terms as Grouper itself.
 */

package edu.internet2.middleware.grouper.app.gsh;
import bsh.CallStack;
import bsh.Interpreter;
import edu.internet2.middleware.grouper.GrouperSession;
import edu.internet2.middleware.grouper.app.usdu.USDU;
import edu.internet2.middleware.grouper.util.GrouperUtil;

/**
 * usdu all
 * <p/>
 * @author  Chris Hyzer
 * @version $Id: usdu.java,v 1.1 2008/09/29 03:38:28 mchyzer Exp $
 * @since   0.0.1
 */
public class usdu {

  /** constant to delete unresolvable memberships */
  public static final int DELETE = 1;

  /**
   * usdu all
   * <p/>
   * @param   interpreter     BeanShell interpreter.
   * @param   stack BeanShell call stack.
   * @return  True if succeeds.
   * @since   0.0.1
   */
  public static String invoke(Interpreter interpreter, CallStack stack) {
    return invoke(interpreter, stack, 0);
  }

  /**
   * usdu all
   * <p/>
   * @param   interpreter     BeanShell interpreter.
   * @param   stack BeanShell call stack.
   * @param options 
   * @return  True if succeeds.
   * @since   0.0.1
   */
  public static String invoke(Interpreter interpreter, CallStack stack, int options) {
    GrouperShell.setOurCommand(interpreter, true);
    try {
      GrouperSession  s = GrouperShell.getSession(interpreter);
      boolean delete = GrouperUtil.hasOption(options, DELETE);
      USDU.resolveMembers(s, delete);
      return "usdu completed successfully";
    } catch (Exception e) {
      GrouperShell.error(interpreter, e);
    }
    return "";    
  } // public static boolean invoke(i, stack, name)

} // public class resetRegistry

